Attribute VB_Name = "Module1"
Option Explicit
Public Const PAGE_READONLY = &H2
Public Const SECTION_MAP_READ = &H4
Public Const FILE_MAP_READ = SECTION_MAP_READ
Public Const SIZE_BMIH = 40     'sizeof(BITMAPINFOHEADER)
Public Const SIZE_BMIFH = 14  'sizeof(BITMAPFILEHEADER)
Public Const GENERIC_READ = &H80000000
Public Const FILE_SHARE_READ = &H1
Public Const OPEN_EXISTING = 3
Public Const FILE_ATTRIBUTE_NORMAL = &H80
Public Const DIB_RGB_COLORS = 0 '  color table in RGBs
Public Const SRCCOPY = &HCC0020 ' (DWORD) dest = source
Public Const PIXELS = 3
Public Const TWIPS = 1
Public Const WHITE = &HFFFFFF
Public Const NVIMAGE_HEIGHT = 116
Public Const VER_PLATFORM_WIN32_NT = 2

'Constants for DEVMODE
Public Const CCHDEVICENAME = 32
Public Const CCHFORMNAME = 32
Public Const NULLPTR = 0&

'Constants for PaperSource Setting
Public Const DM_MODIFY = 8
Public Const DM_IN_BUFFER = DM_MODIFY
Public Const DM_COPY = 2
Public Const DM_OUT_BUFFER = DM_COPY
Public Const DM_DEFAULTSOURCE = &H200

'Constants for DeviceCapabilities Getting
Public Const DC_BINS = 6
Public Const DC_BINNAMES = 12

'Constants for Create Font
Public Const LOGPIXELSY = 90
Public Const FW_NORMAL = 400
Public Const FW_DONTCARE = 0
Public Const DEFAULT_CHARSET = 1
Public Const OUT_DEFAULT_PRECIS = 0
Public Const CLIP_DEFAULT_PRECIS = 0
Public Const DEFAULT_QUALITY = 0
Public Const VERTRES = 10

'OS Version
Public iIsNT As Integer
Public Const VER_ISNT = 2

'Public Papameter
Public prnPrinter  As Printer
Public Const ENTR_TM_DRIVER = "EPSON TM"
Public Const ENTR_BA_DRIVER = "EPSON BA"
Public Const ENTR_EU_DRIVER = "EPSON EU"
Public Const ENTR_DM_DRIVER = "EPSON DM"
Public Const ENTR_RP_DRIVER = "EPSON RP"

'Font Lists
Public Const LF_FACESIZE = 32
Public Const LF_FULLFACESIZE = 64

' ntmFlags field flag
Public Const NTM_REGULAR = &H40&
Public Const NTM_BOLD = &H20&
Public Const NTM_ITALIC = &H1&

'  tmPitchAndFamily flag
Public Const TMPF_FIXED_PITCH = &H1
Public Const TMPF_VECTOR = &H2
Public Const TMPF_DEVICE = &H8
Public Const TMPF_TRUETYPE = &H4

Public Const ELF_VERSION = 0
Public Const ELF_CULTURE_LATIN = 0

'  EnumFonts mask
Public Const RASTER_FONTTYPE = &H1
Public Const DEVICE_FONTTYPE = &H2
Public Const TRUETYPE_FONTTYPE = &H4

Public Const EX_CONTROL_FONT = "controlA"
Public Const EX_CONTROL_FILE = "\TMCTRLA.ini"

Public Type lstPrnFontTbl
    Name As String
    Size As Integer
End Type

Public lstPrnFont(133) As lstPrnFontTbl
Public FontColorFlag As Integer
Public TimerOverFlag As Integer

'used with OpenPrinter command
Public Type DOC_INFO_1
        pDocName As String
        pOutputFile As String
        pDatatype As String
End Type

Type TEXTMETRIC
        tmHeight As Long
        tmAscent As Long
        tmDescent As Long
        tmInternalLeading As Long
        tmExternalLeading As Long
        tmAveCharWidth As Long
        tmMaxCharWidth As Long
        tmWeight As Long
        tmOverhang As Long
        tmDigitizedAspectX As Long
        tmDigitizedAspectY As Long
        tmFirstChar As Byte
        tmLastChar As Byte
        tmDefaultChar As Byte
        tmBreakChar As Byte
        tmItalic As Byte
        tmUnderlined As Byte
        tmStruckOut As Byte
        tmPitchAndFamily As Byte
        tmCharSet As Byte
End Type

Type BITMAPINFOHEADER '40 bytes
        biSize As Long
        biWidth As Long
        biHeight As Long
        biPlanes As Integer
        biBitCount As Integer
        biCompression As Long
        biSizeImage As Long
        biXPelsPerMeter As Long
        biYPelsPerMeter As Long
        biClrUsed As Long
        biClrImportant As Long
End Type

Type RGBQUAD
        rgbBlue As Byte
        rgbGreen As Byte
        rgbRed As Byte
        rgbReserved As Byte
End Type

Type BITMAPINFO
        bmiHeader As BITMAPINFOHEADER
        bmiColors As RGBQUAD
End Type

Type DOCINFO
        cbSize As Long
        lpszDocName As String
        lpszOutput As String
End Type

Public Type OSVERSIONINFO
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String * 128      '  Maintenance string for PSS usage
End Type

Public Type DEVMODE
        dmDeviceName(1 To CCHDEVICENAME) As Byte
        dmSpecVersion As Integer
        dmDriverVersion As Integer
        dmSize As Integer
        dmDriverExtra As Integer
        dmFields As Long
        dmOrientation As Integer
        dmPaperSize As Integer
        dmPaperLength As Integer
        dmPaperWidth As Integer
        dmScale As Integer
        dmCopies As Integer
        dmDefaultSource As Integer
        dmPrintQuality As Integer
        dmColor As Integer
        dmDuplex As Integer
        dmYResolution As Integer
        dmTTOption As Integer
        dmCollate As Integer
        dmFormName(1 To CCHFORMNAME) As Byte
        dmUnusedPadding As Integer
        dmBitsPerPel As Integer
        dmPelsWidth As Long
        dmPelsHeight As Long
        dmDisplayFlags As Long
        dmDisplayFrequency As Long
End Type

Type LOGFONT
        lfHeight As Long
        lfWidth As Long
        lfEscapement As Long
        lfOrientation As Long
        lfWeight As Long
        lfItalic As Byte
        lfUnderline As Byte
        lfStrikeOut As Byte
        lfCharSet As Byte
        lfOutPrecision As Byte
        lfClipPrecision As Byte
        lfQuality As Byte
        lfPitchAndFamily As Byte
        lfFaceName(LF_FACESIZE) As Byte
End Type

Type NEWTEXTMETRIC
        tmHeight As Long
        tmAscent As Long
        tmDescent As Long
        tmInternalLeading As Long
        tmExternalLeading As Long
        tmAveCharWidth As Long
        tmMaxCharWidth As Long
        tmWeight As Long
        tmOverhang As Long
        tmDigitizedAspectX As Long
        tmDigitizedAspectY As Long
        tmFirstChar As Byte
        tmLastChar As Byte
        tmDefaultChar As Byte
        tmBreakChar As Byte
        tmItalic As Byte
        tmUnderlined As Byte
        tmStruckOut As Byte
        tmPitchAndFamily As Byte
        tmCharSet As Byte
        ntmFlags As Long
        ntmSizeEM As Long
        ntmCellHeight As Long
        ntmAveWidth As Long
End Type

Public Declare Function ClosePrinter Lib "winspool.drv" (ByVal _
    hPrinter As Long) As Long

Public Declare Function EndDocPrinter Lib "winspool.drv" (ByVal _
    hPrinter As Long) As Long

Public Declare Function EndPagePrinter Lib "winspool.drv" (ByVal _
    hPrinter As Long) As Long

Public Declare Function OpenPrinter Lib "winspool.drv" Alias _
    "OpenPrinterA" (ByVal pPrinterName As String, phPrinter As Long, _
    ByVal pDefault As Long) As Long

Public Declare Function StartDocPrinter Lib "winspool.drv" Alias _
    "StartDocPrinterA" (ByVal hPrinter As Long, ByVal Level As Long, _
    pDocInfo As DOC_INFO_1) As Long

Public Declare Function StartPagePrinter Lib "winspool.drv" (ByVal _
    hPrinter As Long) As Long

Public Declare Function WritePrinter Lib "winspool.drv" (ByVal _
    hPrinter As Long, pBuf As Any, ByVal cdBuf As Long, _
    pcWritten As Long) As Long

Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Public Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" _
    (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, _
    ByVal dwShareMode As Long, lpSecurityAttributes As Any, _
    ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, _
    ByVal hTemplateFile As Long) As Long

Public Declare Function CreateFileMapping Lib "kernel32" Alias "CreateFileMappingA" _
    (ByVal hFile As Long, lpFileMappigAttributes As Any, _
    ByVal flProtect As Long, ByVal dwMaximumSizeHigh As Long, ByVal _
    dwMaximumSizeLow As Long, ByVal lpName As String) As Long

Public Declare Function MapViewOfFile Lib "kernel32" (ByVal hFileMappingObject As Long, _
    ByVal dwDesiredAccess As Long, ByVal dwFileOffsetHigh As Long, _
    ByVal dwFileOffsetLow As Long, ByVal dwNumberOfBytesToMap As Long) As Long

Public Declare Function StartDoc Lib "gdi32" Alias "StartDocA" _
    (ByVal hdc As Long, lpdi As DOCINFO) As Long

Public Declare Function StartPage Lib "gdi32" (ByVal hdc As Long) As Long

Public Declare Function EndPage Lib "gdi32" (ByVal hdc As Long) As Long

Public Declare Function EndDoc Lib "gdi32" (ByVal hdc As Long) As Long

Public Declare Function StretchDIBits Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, _
    ByVal Y As Long, ByVal dx As Long, ByVal dy As Long, ByVal SrcX As Long, _
    ByVal SrcY As Long, ByVal wSrcWidth As Long, ByVal wSrcHeight As Long, _
    ByVal lpBits As Long, lpBitsInfo As Any, ByVal wUsage As Long, ByVal dwRop As Long) As Long

Public Declare Function UnmapViewOfFile Lib "kernel32" (lpBaseAddress As Any) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
    (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
    
Public Declare Function GetTextMetrics Lib "gdi32" Alias "GetTextMetricsA" _
    (ByVal hdc As Long, lpMetrics As TEXTMETRIC) As Long

'Public Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" _
'    (ByRef lpVersionInformation As OSVERSIONINFO) As Long
Public Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" _
    (lpVersionInformation As OSVERSIONINFO) As Long

Public Declare Function TextOut Lib "gdi32" Alias "TextOutA" _
    (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, _
    ByVal lpString As String, ByVal nCount As Long) As Long

Public Declare Function DocumentProperties Lib "winspool.drv" Alias "DocumentPropertiesA" _
    (ByVal hWnd As Long, ByVal hPrinter As Long, ByVal pDeviceName As String, _
    pDevModeOutput As Any, pDevModeInput As Any, ByVal fMode As Long) As Long

Public Declare Function ResetDC Lib "gdi32" Alias "ResetDCA" _
    (ByVal hdc As Long, lpInitData As Any) As Long

Public Declare Function CreateDC Lib "gdi32" Alias "CreateDCA" _
    (ByVal lpDriverName As String, ByVal lpDeviceName As String, _
    ByVal lpOutput As Long, ByVal lpInitData As Long) As Long
    
Public Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long

Public Declare Function DeviceCapabilities Lib "winspool.drv" Alias "DeviceCapabilitiesA" _
    (ByVal lpDeviceName As String, ByVal lpPort As String, ByVal iIndex As Long, _
    lpOutput As Any, ByVal dev As Long) As Long

Public Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" _
    (ByVal H As Long, ByVal W As Long, ByVal E As Long, ByVal O As Long, _
    ByVal W As Long, ByVal I As Long, ByVal u As Long, ByVal S As Long, _
    ByVal C As Long, ByVal OP As Long, ByVal CP As Long, ByVal Q As Long, _
    ByVal PAF As Long, ByVal F As String) As Long
    
Public Declare Function MulDiv Lib "kernel32" _
    (ByVal nNumber As Long, ByVal nNumerator As Long, ByVal nDenominator As Long) As Long

Public Declare Function GetDeviceCaps Lib "gdi32" _
    (ByVal hdc As Long, ByVal nIndex As Long) As Long
    
Public Declare Function SelectObject Lib "gdi32" _
    (ByVal hdc As Long, ByVal hObject As Long) As Long

Declare Function EnumFontFamilies Lib "gdi32" Alias "EnumFontFamiliesA" _
    (ByVal hdc As Long, ByVal lpszFamily As String, _
    ByVal lpEnumFontFamProc As Long, LParam As Any) As Long
    
Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" _
    (ByVal lpAppName As String, lpReturnedString As Byte, _
    ByVal nSize As Long, ByVal lpFileName As String) As Long
    
Declare Function GetPrintProcessorDirectory Lib "winspool.drv" Alias "GetPrintProcessorDirectoryA" _
    (ByVal pName As String, ByVal pEnvironment As String, _
    ByVal Level As Long, pPrintProcessorInfo As Byte, _
    ByVal cdBuf As Long, pcbNeeded As Long) As Long
    
Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long

    
'Printer Font Table
Public lstPrnFontTbl() As String
Public lstDMDFontTbl() As String
Public Function EnumGetFontCount(lpNLF As LOGFONT, lpNTM As NEWTEXTMETRIC, _
    ByVal FontType As Long, LParam As Integer) As Long
    LParam = LParam + 1
    EnumGetFontCount = 1
End Function

Public Function EnumGetFontName(lpNLF As LOGFONT, lpNTM As NEWTEXTMETRIC, _
    ByVal FontType As Long, LParam As Integer) As Long
    Dim FaceName As String
    
    FaceName = StrConv(lpNLF.lfFaceName, vbUnicode)
    lstPrnFontTbl(LParam) = Left$(FaceName, InStr(FaceName, vbNullChar) - 1)
    
    LParam = LParam + 1
    EnumGetFontName = 1
End Function

Public Function EnumGetDMDFontName(lpNLF As LOGFONT, lpNTM As NEWTEXTMETRIC, _
    ByVal FontType As Long, LParam As Integer) As Long
    Dim FaceName As String
    
    FaceName = StrConv(lpNLF.lfFaceName, vbUnicode)
    lstDMDFontTbl(LParam) = Left$(FaceName, InStr(FaceName, vbNullChar) - 1)
    
    LParam = LParam + 1
    EnumGetDMDFontName = 1
End Function



